<?php
// +----------------------------------------------------------------------+
// | RemessaPHP - Verso 1.0                                              |
// +----------------------------------------------------------------------+
// | Este arquivo est disponvel sob a Licena GPL disponvel pela Web   |
// | em http://pt.wikipedia.org/wiki/GNU_General_Public_License           |
// | Voc deve ter recebido uma cpia da GNU Public License junto com     |
// | esse pacote; se no, escreva para:                                   |
// |                                                                      |
// | Free Software Foundation, Inc.                                       |
// | 59 Temple Place - Suite 330                                          |
// | Boston, MA 02111-1307, USA.                                          |
// +----------------------------------------------------------------------+

// +--------------------------------------------------------------------------+
// | SCRIPT: GERAR ARQUIVOS DE REMESSA CNAB-240 DA CAIXA ECONOMICA FEDERAL    |
// |                                                                          |
// | AUTORES:                                                                 |
// |         ALEXANDRE GUIMARAES SARMENTO                                     |
// |         remessaphp@remessaphp.com.br                                     |
// |         SAO LUIS - MA                                                    |
// |                                                                          |
// |         MARCELO CAJAIBA                                                  |
// |         marcelocajaiba@gmail.com                                         |
// |         TEOFILO OTONI - MG                                               |
// |                                                                          |
// | DATA:   25/11/2016                                                       |
// +--------------------------------------------------------------------------+
?>

<?php
// *****************************************************************************************************************
// INICIO DAS FUNCOES --> NAO ALTERAR AS FUNCOES DO SCRIPT
// *****************************************************************************************************************
?>

<?php
function remover_acentos($str) 
{ 
  $a = array('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', '', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', '?', '?', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', '?', '?', 'L', 'l', 'N', 'n', 'N', 'n', 'N', 'n', '?', 'O', 'o', 'O', 'o', 'O', 'o', '', '', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', '', '', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', '', 'Z', 'z', 'Z', 'z', '', '', '?', '', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', '?', '?', '?', '?', '?', '?', '', ''); 
  $b = array('A', 'A', 'A', 'A', 'A', 'A', 'AE', 'C', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'D', 'N', 'O', 'O', 'O', 'O', 'O', 'O', 'U', 'U', 'U', 'U', 'Y', 's', 'a', 'a', 'a', 'a', 'a', 'a', 'ae', 'c', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'i', 'n', 'o', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'u', 'y', 'y', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', 'D', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'IJ', 'ij', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', 'L', 'l', 'l', 'l', 'N', 'n', 'N', 'n', 'N', 'n', 'n', 'O', 'o', 'O', 'o', 'O', 'o', 'OE', 'oe', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', 'S', 's', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', 'Y', 'Z', 'z', 'Z', 'z', 'Z', 'z', 's', 'f', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'A', 'a', 'AE', 'ae', 'O', 'o','c','C'); 
  return str_replace($a, $b, $str); 
} 

function post_slug($str) 
{ 
  return strtoupper(preg_replace(array('/[^a-zA-Z0-9 -]/', '/[ -]+/', '/^-|-$/'), 
  array('', '-', ''), remover_acentos($str))); 
} 
?> 

<?php
/*Campos Numricos (Picture 9)
 Alinhamento: sempre  direita, preenchido com zeros  esquerda, sem mscara de edio;
 No utilizados: preencher com zeros.
*/
function picture_9($palavra,$limite){
	$var=str_pad($palavra, $limite, "0", STR_PAD_LEFT);
	return $var;
}

/*
Campos Alfanumricos (Picture X)
 Alinhamento: sempre  esquerda, preenchido com brancos  direita;
 No utilizados: preencher com brancos;
 Caracteres: maisculos, sem acentuao, sem , sem caracteres especiais.
*/
	 
function picture_x( $palavra, $limite ){
	$var = str_pad( $palavra, $limite, " ", STR_PAD_RIGHT );
	$var = remover_acentos( $var );
	if( strlen( $palavra ) >= $limite ){
		$var = substr( $palavra, 0, $limite );
	}
	$var = strtoupper( $var );// converte em letra maiuscula
	return $var;
}	 
	 
function sequencial($i)
{
if($i < 10)
{
return zeros(0,5).$i;
}
else if($i > 10 && $i < 100)
{
return zeros(0,4).$i;
}
else if($i > 100 && $i < 1000)
{
return zeros(0,3).$i;
}
else if($i > 1000 && $i < 10000)
{
return zeros(0,2).$i;
}
else if($i > 10000 && $i < 100000)
{
return zeros(0,1).$i;
}
}

function zeros($min,$max)
{
$x = ($max - strlen($min));
for($i = 0; $i < $x; $i++)
{
$zeros .= '0';
}
return $zeros.$min;
}

function complementoRegistro($int,$tipo)
{
if($tipo == "zeros")
{
$space = '';
for($i = 1; $i <= $int; $i++)
{
$space .= '0';
}
}
else if($tipo == "brancos")
{
$space = '';
for($i = 1; $i <= $int; $i++)
{
$space .= ' ';
}
}

return $space;
}

$fusohorario     = 3; // como o servidor de hospedagem  a dreamhost pego o fuso para o horario do brasil
$timestamp       = mktime(date("H") - $fusohorario, date("i"), date("s"), date("m"), date("d"), date("Y"));

$DATAHORA['PT']  = gmdate("d/m/Y H:i:s", $timestamp);
$DATAHORA['EN']  = gmdate("Y-m-d H:i:s", $timestamp);
$DATA['PT']      = gmdate("d/m/Y", $timestamp);
$DATA['EN']      = gmdate("Y-m-d", $timestamp);
$DATA['DIA']     = gmdate("d",$timestamp);
$DATA['MES']     = gmdate("m",$timestamp);
$DATA['ANO']     = gmdate("Y",$timestamp);
$HORA            = gmdate("H:i:s", $timestamp);
$HORA1           = gmdate("His", $timestamp);

define("REMESSA",$PATH."",true);

// *****************************************************************************************************************
// FIM DAS FUNCOES 
// *****************************************************************************************************************

$xid_remessa     = 50;   // ID DA REMESSA. CADA REMESSA TEM QUE TER UMA NUMERACAO PROPRIA NUMERICA E CRESCENTE 
$arquivo         = "E".date("d")."000".$xid_remessa.".REM";  // nome do arquivo da remessa no formato EDD000Y.REM, onde DD = dia da geracao, Y=numero da remessa
                                                              // p.ex. E2500050.REM
$filename        = $arquivo 

// *****************************************************************************************************************
// NAO ALTERAR --> DADOS DE PARAMETRIZACAO DO SISTEMA DE COBRANCA DOS BOLETOS
// *****************************************************************************************************************

$conteudo        = '';
$lote_sequencial = 1; // contador para cada item P, Q e R
$lote_servico    = 1; // para cobrana registrada usar: 1
$header          = ''; // linha header - primeira linha do arquivo de remessa
$header_lote     = ''; // linha header de lote - segunda linha do arquivo de remessa
$linha_p         = ''; // linha Segmento P - Registro tipo 3 (loop)
$linha_q         = ''; // Linha Segmento Q - Registro tipo 3 (loop)
$linha_r         = ''; // Linha Segmento R - Registro tipo 3 (loop)
                       // OBS: As linhas P, Q e R sempre existirao para cada boleto a ser enviado ao banco. 
					   // a linha P = dados do boleto / linha R = Dados do pagador / linha R = Dados da multa                     
$linha_5         = ''; // Linha Segmento 5 - Registro tipo 5 - pnultima linha do arquivo de remessa
$linha_9         = ''; // Linha Segmento 9 - Registro tipo 9 - ultima linha do arquivo de remessa
$conteudo_meio   = ''; // Variavel para juncao das linhas P, Q e R
$qtd_titulos     = 0;  // Quantidade inicial de titulos da remessa
$total_valor     = 0;  // Valor inicial para o somatorio do valor dos boletos da remessa
$numero_sequencial_arquivo = $xnumero_seq; // cada arquivo gerado dever ter uma sequencia 

// *****************************************************************************************************************
// DADOS DE PARAMETRIZACAO DO SISTEMA DE COBRANCA DOS BOLETOS - ALTERE SE PREFERIR USAR VALOR FIXO AO INVES DE TAXAS
// *****************************************************************************************************************

$forma_cobrar_juros = '2';   // 27.3P -> JUROS --> Tipo de preferncia: 1 = Valor por Dia / 2 = Taxa Mensal  / 3 = Isento
$taxa_juros_mes     = '100'; // TAXA DE JUROS AO MES COM 2 CASAS DECIMAIS

$valor_multa        = '200'  // taxa percentual da multa por atraso contendo 2 (duas) casas decimais. P.ex. aqui e' 2,00 %

$forma_desconto     = '2';   // 30.3P -> DESCONTO 1 --> Cod. do desconto 1. Tipo: 0 = Sem Desconto / 1 = Valor Fixo / 2 = Percentual





// *****************************************************************************************************************
// DADOS DA EMPRESA EMISSORA DO BOLETO - MUDE AQUI E COLOQUE OS DADOS DE SUA EMPRESA
// *****************************************************************************************************************
// ALTERE AQUI OS DADOS DE ACORDO COM SUA EMPRESA EMISSORA DOS BOLETOS
// *****************************************************************************************************************

$carteira                  = 14; // carteira de boleto com registro da caixa comeca sempre com 14
$cpf_cnpj                  = '12910140000186'; // cnpj da empresa ou escola
$agencia                   = '1577'; // numero da agencia da escola
$dv_agencia                = '0';        // digito da agenda --> verificar se isso esta correto olhando no arquivo de retorno
$codigo_beneficiario       = '258509'; // numero do cedente
$empresa_beneficario       = 'DANIEL SILVA DE SOUZA (INFINITY IDIOMAS)'; // nome da empresa tal como esta cadastrado na caixa

// *****************************************************************************************************************
// REGISTRO HEADER - ( TIPO 0 )
// PARTE 1 - 1 Linha do arquivo ( PAG: 18 do manual da Caixa )
// *****************************************************************************************************************
// NO ALTERAR A VARIAVEL [ $header ] ABAIXO
// *****************************************************************************************************************

$header .= '104';                                       // 01.0 -> Cod. do banco no caso da caixa = 104 
$header .= complementoRegistro(4,"zeros");              // 02.0 -> Cod. do lote
$header .= complementoRegistro(1,"zeros");              // 03.0 -> Tipo de Registro
$header .= complementoRegistro(9,"brancos");            // 04.0 -> CNAB literal remessa escr. extenso 003 009 X(07)
$header .= '2';                                         // 05.0 -> Tipo de inscrio do beneficiario : um se pessoa fisico (1) ou juridica (2)
$header .= picture_9($cpf_cnpj,14);                     // 06.0 -> N de Inscrio do Beneficiario cpf ou cnpj da escola emissora do boleto
$header .= complementoRegistro(20,"zeros");             // 07.0 -> Uso exclusivo da caixa, preencher com zeros
$header .= picture_9($agencia,5);                       // 08.0 -> Cod. da agencia mantenedora da conta
$header .= picture_9($dv_agencia,1);                    // 09.0 -> Digito verificador
$header .= picture_9($codigo_beneficiario,6);           // 10.0 -> Cod. do beneficirio fornecido pelo banco - N do cedente
$header .= complementoRegistro(7,"zeros");              // 11.0 -> Uso exclusivo da caixa, preencher com 7 zeros
$header .= complementoRegistro(1,"zeros");              // 12.0 -> Uso exclusivo da caixa, preencher com 1 zeros
$header .= picture_x($empresa_beneficario,30);          // 13.0 -> Nome da empresa
$header .= picture_x('CAIXA ECONOMICA FEDERAL',30);     // 14.0 -> Nome do banco, neste caso: CAIXA ECONOMICA FEDERAL ate completar 30 espacos
$header .= complementoRegistro(10,"brancos");           // 15.0 -> 10 espaos em banco
$header .='1';                                          // 16.0 -> Cod. (1) = Remessa ou (2) = Retorno.
$header .= $DATA['DIA'].$DATA['MES'].$DATA['ANO'];      // 17.0 -> Data da geracao arquivo 
$header .= $HORA1;                                      // 18.0 -> Hora da geracao arquivo 
$header .= picture_9($numero_sequencial_arquivo,6);     // 19.0 -> Sequencial do arquivo um numero novo para cada arquivo de remessa que for gerado
$header .='050';                                        // 20.0 -> Nova versao da leitura
$header .= complementoRegistro(5,"zeros");              // 21.0 -> Densidade de Gravacao do Arquivo
$header .= complementoRegistro(20,"brancos");           // 22.0 -> Filler
$header .= picture_x('REMESSA-PRODUCAO',20);            // 23.0 -> Preencher com REMESSA-TESTE' na fase de testes(simulado) ou REMESSA-PRODUCAO quando OK
$header .= complementoRegistro(4,"brancos");            // 24.0 -> Preencher com espacos
$header .= complementoRegistro(25,"brancos");           // 25.0 -> Preencher com espacos
$header .= chr(13).chr(10);                             // QUEBRA DE LINHA

// *****************************************************************************************************************
// DESCRICAO DE REGISTRO - ( TIPO 1 )
// HEADER DE LOTE DE ARQUIVO REMESSA
// PARTE 2 - 2 linha do arquivo - ( PAG: 20 DO MANUAL DA CAIXA )
// *****************************************************************************************************************
// NO ALTERAR A VARIAVEL [ $header_lote ] ABAIXO
// *****************************************************************************************************************

$header_lote .= '104';                                       // 01.1 -> Cod. do banco, neste caso = 104
$header_lote .= picture_9($lote_servico,4);                  // 02.1 -> Lote de servico = igual ao campo 02.1 do header acima
$header_lote .='1';                                          // 03.1 -> Preencher '1 (equivale a Header de Lote)
$header_lote .='R';                                          // 04.1 -> Preencher R (equivale a Arquivo Remessa)
$header_lote .='01';                                         // 05.1 -> Preencher com 01', se Cobrana Registrada; ou 02, se Cobrana Sem Registro/Servios
$header_lote .= complementoRegistro(2,"zeros");              // 06.1 -> Preencher com zeros
$header_lote .='030';                                        // 07.1 -> No. da verso do layout. Preencher com 030
$header_lote .= complementoRegistro(1,"brancos");            // 08.1 -> Preencher com espacos
$header_lote .= '2';                                         // 09.1 -> Tipo de inscrio do beneficiario : um se pessoa fisico (1) ou juridica (2)
$header_lote .= picture_9($cpf_cnpj,15);                     // 10.1 -> CNPJ = Nmero de Inscrio do  Beneficirio cpf ou cnpj
$header_lote .= picture_9($codigo_beneficiario,6);           // 11.1 -> COD. CEDENTE ou COD. DO CONVENIO NO BANCO = cdigo do beneficirio fornecido pelo banco 
$header_lote .= complementoRegistro(14,"zeros");             // 11.1 -> Uso exclusivo da caixa, preencher com zeros
$header_lote .= picture_9($agencia,5);                       // 12.1 -> Agencia mantenedora da conta
$header_lote .= picture_9($dv_agencia,1);                    // 13.1 -> Digito verificador
$header_lote .= picture_9($codigo_beneficiario,6);           // 14.1 -> CEDENTE = Cod do beneficirio fornecido pelo banco 
$header_lote .= complementoRegistro(7,"zeros");              // 15.1 -> Cod fornecido pela CAIXA/Grfica,utilizado se boleto personalizado; do contrrio,preencher com zeros
$header_lote .= complementoRegistro(1,"zeros");              // 16.1 -> Uso exclusivo da caixa
$header_lote .= picture_x($empresa_beneficario,30);          // 17.1 -> Nome da empresa
$header_lote .= complementoRegistro(40,"brancos");           // 18.1 -> mensagem 1
$header_lote .= complementoRegistro(40,"brancos");           // 19.1 -> mensagem 2
$header_lote .= picture_9($numero_sequencial_arquivo,8);     // 20.1 -> Controle de cobranca - No. da remessa, mesmo que 19.0
$header_lote .= $DATA['DIA'].$DATA['MES'].$DATA['ANO'];      // 21.1 -> Controle de cobranca - Data de gravacao do arquivo de remessa
$header_lote .= complementoRegistro(8,"zeros");              // 22.1 -> Data do credito. Preencher com zeros
$header_lote .= complementoRegistro(33,"brancos");           // 23.1 -> CNAB. Preencher com espacos 
$header_lote .= chr(13).chr(10);                             // Quebra de linha

$num_seg_linha_p_q_r = 1;  // Variavel para armazenas a quantidade do total de registros P, Q e R em nosso arquivo de remessa. Esse total e' usado
                           // na penultima e ultima linha do arquivo de remessa.

// *****************************************************************************************************************
// ALGUNS COMENTARIOS SOBRE O QUE VIRA A SEGUIR
// *****************************************************************************************************************
// INICIO DO LOOP PARA OBTER DADOS DOS BOLETOS E DOS TITULOS QUE ESTAO NO BANCO DE DADOS DE SUA APLICACAO
// ESSES DADOS IRAO MONTAR AS LINHAS P, Q e R
// A LINHA P = DADOS DO BOLETO ou TITULO
// A LINHA Q = DADOS DO PAGADOR
// A LINHA R = DADOS REF. A MULTA POR ATRASO DOS BOLETOS
// *****************************************************************************************************************

$total = 1; // QUANTIDADE DE BOLETOS QUE EXISTENTES NO SEU BANCO DE DADOS. ESTOU USANDO O VALOR DE 1 APENAS PARA LIMITAR EM 1 LINHA P,Q e R
            // SE VOCE TIVER 2 (DOIS) BOLETOS, SERAO 2 LINHAS P,Q e R. SE FOREM 3 BOLETOS A SEREM ENVIADOS, SERO 3 LINHA P, Q e R.
			// E POR AI VAI. COMO ESTAMOS MOSTRANDO AQUI UM EXEMPLO, IREMOS FAZER COMO SE FOSSE APENAS 1 BOLETO A SER ENVIADO.
			


for( $j=0; $j<$total; $j++ ){

	// *****************************************************************************************************************
	// DESCRICAO DE REGISTRO - ( TIPO 3 ) , Segmento "P":
	// DADOS DO TITULO
	// PARTE 3
	// TAMANHO DO REGISTRO = 240 CARACTERES - ( PAGINA 22 DO MANUAL DA CAIXA )
	// REGISTRO DETALHE (OBRIGATORIO)  - VARIAVEIS DO PAGADOR E DO TITULO
	// *****************************************************************************************************************

	$i                               = 2;          // NO MEXER E DEIXAR SEMPRE O VALOR 2                         

	// *****************************************************************************************************************
	// DADOS DO BOLETO QUE IREMOS REMETER EM NOSSO ARQUIVO DE REMESSA
	// *****************************************************************************************************************
	// ALTERAR DE ACORDO COM OS DADOS DO SEU BOLETO
	// *****************************************************************************************************************
	
	$nosso_numero                    = '326743'; // NOSSO NUMERO USADO NO SEU BOLETO E QUE SERA ENVIADO AO BANCO
	$numero_documento                = $nosso_numero;
	$data_vencimento_boleto          = '20122016'; // DATA DE VENCIMENTO DO BOLETO
	$data_multa                      = '21122016'; // DATA PARA COBRANCA DE MULTA POR ATRASO DE PAGAMENTO DO BOLETO
	$data_emissao_boleto             = '20112016'; // DATA DE EMISSAO DO BOLETO
	$valor_boleto                    = '25045';    // VALOR DO BOLETO COM 2 CASAS DECIMAIS --> R$ 250,45
	$data_juros                      = '21122016'; // DATA DOS JUROS
	$valor_juros                     = '100';      // VALOR DA TAXA DE JUROS COM 2 CASAS DECIMAIS --> INFORMAR SEMPRE A TAXA AO MES. AQUI ==> 1% AO MES
	$data_desconto                   = '20122016'; // DATA LIMITE PARA APLICACAO DO DESCONTO DO BOLETO
	$valor_desconto                  = '1367';     // VALOR DA TAXA DE DESCONTO, AQUI => 13,67% SOBRE O VALOR NOMINAL DO TITULO
	$valor_iof                       = '000'       // VALOR DO IOF ( *** PODE DEIXAR ZERADO)
    $valor_abatimento                = '000'       // VALOR DO ABATIMENTO. ( *** PODE DEIXAR ZERADO) PORQUE NAO E' A MESMA COISA QUE DESCONTO

	// *****************************************************************************************************************
	// DADOS DO PAGADOR DO TITULO
	// *****************************************************************************************************************
	// ALTERAR DE ACORDO COM OS DADOS DE QUEM IRA PAGAR O BOLETO OU SEJA, O PAGADOR
	// *****************************************************************************************************************

	$tipo_inscricao_pagador          = '1' // Tipo de inscrio do pagador / 1 = pessoa fisica / 2 = pessoa juridica
	$numero_inscricao_pagador        = '40529582325';  // ESSE CPF TEM QUE SER VALIDO JUNTO A RECEITA FEDERAL. ESTE USADO AQUI E' APENAS 1 EXEMPLO E FICTICIO. USE UM VALIDO.
	$nome_pagador                    = 'JOSE DA SILVA SOUSA SANTOS MELO REGO'; // NAO USAR CARACTERES ACENTUADOS, COM TIL, CEDILHA OU SIMBOLOS
	$endereco_pagador                = 'AV JOSE DO RIO BRANCO 38'; // ENDERECO
	$bairro_pagador                  = 'CENTRO DAS CUNHAS'; // BAIRRO  
	$cep_pagador                     = '65072'; // AS 05 (CINCO) PRIMEIRAS POSICOES DO CEP. OBS: DEVE SER UM CEP VALIDO JUNTO AOS CORREIOS, SENAO DA ERRO. AQUI USEI 1 FICTICIO
	$cep_pagador_sufixo              = '300'; // OS 03 (TRES) ULTIMOS DIGITOS DO CEP.
	$cidade_pagador                  = 'SAO LUIS'; // CIDADE
	$estado_pagador                  = 'MA'; // ESTADO 
	$email_pagador                   = 'ALEXANDRE890@YAHOO.COM.BR'; // EMAIL
	
	// *****************************************************************************************************************
    // NAO ALTERAR A VARIAVEL [ $linha_p ] ABAIXO
 	// *****************************************************************************************************************
		
	$linha_p .= '104';                                   // 01.3P -> CCONTROLE. COD. DO BANCO, Neste caso = 104
	$linha_p .= picture_9($lote_servico,4);              // 02.3P -> CONTROLE. LOTE DE SERVICO. TEM QUE SER IGUAL AO HEADER DE LOTE DO CAMPO 02.1 
	$linha_p .= '3';                                     // 03.3P -> CONTROLE. TIPO DE REGISTRO. Preencher com 3 (EQUIVALE A DETALHE DO LOTE)
	$linha_p .= picture_9($num_seg_linha_p_q_r,5);       // 04.3P -> SERVICO. N Sequencial do Registro no Lote. (G038). EVOLUIR DE 1 EM 1 PARA CADA SEGMENTO DO LOTE
	$linha_p .= 'P';                                     // 05.3P -> SERVICO. Cd. Segmento do Registro Detalhe, PREENCHER P
	$linha_p .= complementoRegistro(1,"brancos");        // 06.3P -> SERVICO. Preencher com espaco
	$linha_p .= picture_9('01',2);                       // 07.3P -> SERVICO. Cod. de movimento remessa. 1=entrada/2=baixa/6=alterar vencimento (C004)
	$linha_p .= picture_9($agencia,5);                   // 08.3P -> COD. ID. BENEFICIARIO. Agencia mantenedora da conta
	$linha_p .= picture_9($dv_agencia,1);                // 09.3P -> COD. ID. BENEFICIARIO. Digito verificador
	$linha_p .= picture_9($codigo_beneficiario,6);       // 10.3P -> COD. ID. BENEFICIARIO. Cod. do convenio no banco ou Cd. CEDENTE. 
	$linha_p .= complementoRegistro(8,"zeros");          // 11.3P -> COD. ID. BENEFICIARIO. Uso Exclusivo CAIXA - Filler
	$linha_p .= complementoRegistro(3,"zeros");          // 12.3P -> USO EXCLUSIVO DA CAIXA. Filler
	$linha_p .= picture_9($carteira,2);                  // 13.3P -> CARTEIRA/NOSSO NUMERO. Modalidade de Carteira = tipo de carteira do boleto (14 OU 24) com ou sem registro
	$linha_p .= picture_9($nosso_numero,15);             // 13.3P -> CARTEIRA/NOSSO NUMERO. Identificacao do titulo no banco = Nosso numero 
	$linha_p .='1';                                      // 14.3P -> codigo da carteira (1) equivale a cobrana simples (C006)
	$linha_p .='1';                                      // 15.3P -> Forma de Cadastramento do Ttulo no Banco. 1=cobranca registrada / 2=cobranca sem registro
	$linha_p .='2';                                      // 16.3P -> Tipo de Documento - Preencher '2 (equivale a Escritural)
	$linha_p .='2';                                      // 17.3P -> Identificao da Emissao do boleto. 1 = Banco emite/ 2 = Cliente emite (C009)
	$linha_p .='0';                                      // 18.3P -> Identificacao da Entrega do boleto. (C010)
	$linha_p .= picture_9($numero_documento,11);         // 19.3P -> Numero do documento de cobranca. (C011) = meu numero de boleto
	$linha_p .= complementoRegistro(4,"brancos");        // 19.3P -> espacos
	$linha_p .= picture_9($data_vencimento_boleto,8);    // 20.3P -> Data de vencimento do ttulo, no formato DDMMAAAA (Dia, Mse Ano);
	$linha_p .= picture_9($valor_boleto,15);             // 21.3p -> Valor nominal do ttulo,utilizando 2 casas decimais (exemplo:ttulo de valor 530,44 - preencher 0000000053044)
	$linha_p .= complementoRegistro(5,"zeros");          // 22.3P -> Agncia Encarregada da Cobrana (Preencher com zeros)
	$linha_p .= complementoRegistro(1,"zeros");          // 23.3P -> DV (Preencher com zeros)
	$linha_p .= picture_x('99',2);                       // 24.3P -> Espcie do Ttulo (NF: NOTA FISCAL, DD:DOCUMENTO DE DIVIDA, CPR: CDULA DE PRODUTO RURAL, OU:OUTROS = 99
	$linha_p .= picture_x('N',1);                        // 25.3P -> Aceite. preencher com A (Aceite) ouN (No Aceite)
	$linha_p .= picture_9($data_emissao_boleto,8);       // 26.3P -> Data de emissjo do ttulo, no formato DDMMAAAA (Dia, Mse Ano);
	$linha_p .= picture_9($forma_cobrar_juros,1);        // 27.3P -> JUROS --> Tipo de preferncia: 1 = Valor por Dia / 2 = Taxa Mensal  / 3 = Isento
	$linha_p .= picture_9($data_juros,8);                // 28.3P -> JUROS --> Data incio cobrana de Juros formato DDMMAAAA (Dia, Ms e Ano). OBS: TEM QUE TER UMA DATA
	$linha_p .= picture_9($taxa_juros_mes,15);           // 29.3P -> JUROS --> Taxa de Juros de mora por mes, contendo 2 (duas) casas decimais. Aqui e' 100 => 1% ao mes 
	$linha_p .= picture_9($forma_desconto,1);            // 30.3P -> DESCONTO 1 --> Cod. do desconto 1. Tipo: 0 = Sem Desconto / 1 = Valor Fixo / 2 = Percentual
	$linha_p .= picture_9($data_desconto,8);             // 31.3P -> DESCONTO 1 --> Data do desconto
	$linha_p .= picture_9($valor_desconto,15);           // 32.3P -> DESCONTO 1 --> Valor/percentual do desconto a ser concedido
	$linha_p .= picture_9($valor_iof,15);                // 33.3P -> VLR. IOF. Valor do IOF a ser recolhido
	$linha_p .= picture_9($valor_abatimento,15);         // 34.3P -> Valor do abatimento
	$linha_p .= picture_9($numero_documento,25);         // 35.3P -> Uso empresa cedente. Identificacao do titulo na empresa. Identico ao campo 19.3P
	$linha_p .= '3';                                     // 36.3P -> Cdigo para Protesto. 1 = protestar / 3 = nao protestar
	$linha_p .= '00';                                    // 37.3P -> Prazo para protesto. Numero de dias para  Protesto
	$linha_p .= '1';                                     // 38.3P -> Cdigo p/ Baixa/Devoluo: Preencher - vencido: '1 (Baixar/ Devolver) ou 2 (No Baixar / No Devolver
	$linha_p .= picture_9('090',3);                      // 39.3P -> Prazo p/ baixa/devolucao. Numero de dias para baixa/devolucao. 
   	$linha_p .= picture_9('9',2);                        // 40.3P -> Codigo da moeda. 09 = REAL
	$linha_p .= complementoRegistro(10,"zeros");         // 41.3P -> Preencher com zeros
	$linha_p .= complementoRegistro(1,"brancos");        // 42.3P -> Preencher com espacos
	$linha_p .= chr(13).chr(10);                         // essa  a quebra de linha
	
	$num_seg_linha_p_q_r++;
	
	$qtd_titulos++;
	
	$total_valor+=$valor_boleto;

	// *****************************************************************************************************************
	// DESCRICAO DE REGISTRO - ( TIPO 3 ) , Segmento "Q":
	// DADOS DO PAGADOR E SACADOR/AVALISTA
	// PARTE 4
	// TAMANHO DO REGISTRO = 240 CARACTERES
	// *****************************************************************************************************************
	// NO ALTERAR A VARIAVEL [ $linha_q ] ABAIXO
	// *****************************************************************************************************************

	$linha_q .= '104';                                   // 01.3Q -> Cod. Banco. Caixa = 104 
	$linha_q .= picture_9($lote_servico,4);              // 02.3Q -> Lote de servio
	$linha_q .= '3';                                     // 03.3Q -> tipo de registro. Equivalente a detalhe de lote. preencher '3'
	$linha_q .= picture_9($num_seg_linha_p_q_r,5);       // 04.3Q -> N Sequencial do Registro no Lote
	$linha_q .= 'Q';                                     // 05.3Q -> Cd. Segmento do Registro Detalhe
	$linha_q .= complementoRegistro(1,"brancos");        // 06.3Q -> Espaco
	$linha_q .= picture_9('01',2);                       // 07.3Q -> Cod de Movimento Remessa
	$linha_q .= $tipo_inscricao_pagador;                 // 08.3Q -> Tipo de Inscricao do Pagador (1) CPF (pessoa fsica) (2) CNPJ Pessoa jurdica
	$linha_q .= picture_9($numero_inscricao_pagador,15); // 09.3Q -> cpf ou cnpj
	$linha_q .= picture_x($nome_pagador,40);             // 10.3Q -> Nome do pagador
	$linha_q .= picture_x($endereco_pagador,40);         // 11.3Q -> Endereco do pagador
	$linha_q .= picture_x($bairro_pagador,15);           // 12.3Q -> Bairro
	$linha_q .= picture_9($cep_pagador,5);               // 13.3Q -> Cep (primeiros 5 digitos => p.ex 65072 )
	$linha_q .= picture_9($cep_pagador_sufixo,3);        // 14.3Q -> Cep (sufixo ou o complento de 3 digitos => p.ex 110 )
	$linha_q .= picture_x($cidade_pagador,15);           // 15.3Q -> Cidade
	$linha_q .= picture_x($estado_pagador,2);            // 16.3Q -> UF
	$linha_q .= '0';                                     // 17.3Q -> Tipo de Inscrio do sacador AVALISTA (0) nenhum (1) CPF (pessoa fsica) (2) CNPJ Pessoa jurdica
	$linha_q .= picture_9('0',15);                       // 18.3Q -> CPF ou CNPJ do Sacador avalista
	$linha_q .= complementoRegistro(40,"brancos");       // 19.3Q -> nome do sacador avalista
	$linha_q .= complementoRegistro(3,"brancos");        // 20.3Q -> Zeros
	$linha_q .= complementoRegistro(20,"brancos");       // 21.3Q -> Espaco
	$linha_q .= complementoRegistro(8,"brancos");        // 22.3Q -> Espaco
	
	$tam_linha_q  = strlen($linha_q);
	$zeros_rest_2 = 240 - $tam_linha_q;
	$linha_q      = $linha_q.complementoRegistro($zeros_rest_2,"zeros");

	$linha_q .= chr(13).chr(10);                         // essa  a quebra de linha
 
 	$num_seg_linha_p_q_r++;
	
	
// ********************

	// *****************************************************************************************************************
	// DESCRICAO DE REGISTRO - ( TIPO 3 ) , Segmento "R":
	// DADOS DO PAGADOR E SACADOR/AVALISTA
	// PARTE 4
	// TAMANHO DO REGISTRO = 240 CARACTERES
	// *****************************************************************************************************************
	// NO ALTERAR A VARIAVEL [ $linha_r ] ABAIXO
	// *****************************************************************************************************************
	
	$linha_r .= '104';                                   // 01.3R -> Cod. Banco. Caixa = 104 
	$linha_r .= picture_9($lote_servico,4);              // 02.3R -> Lote de servio
	$linha_r .= '3';                                     // 03.3R -> tipo de registro. Equivalente a detalhe de lote. preencher '3'
	$linha_r .= picture_9($num_seg_linha_p_q_r,5);       // 04.3R -> N Sequencial do Registro no Lote
	$linha_r .= 'R';                                     // 05.3R -> Cd. Segmento do Registro Detalhe
	$linha_r .= complementoRegistro(1,"brancos");        // 06.3R -> Espaco
	$linha_r .= picture_9('01',2);                       // 07.3R -> Cod. Movimento Rem = 01 => Entrada de titulo Nota Explicativa: (C004)

	$linha_r .= '0';                                     // 08.3R -> DESCONTO-2. COD. DESCONTO / 0=sem / 1=valor fixo / 2=valor percentual
    $linha_r .= picture_9('0',8);                        // 09.3R -> DESCONTO-2. DATA DESCONTO 
    $linha_r .=	picture_9('0',15);                       // 10.3R -> DESCONTO-2. VALOR DO DESCONTO

	$linha_r .= '0';                                     // 11.3R -> DESCONTO-3. COD. DESCONTO / 0=sem / 1=valor fixo / 2=valor percentual
    $linha_r .= picture_9('0',8);                        // 12.3R -> DESCONTO-3. DATA DESCONTO 
    $linha_r .=	picture_9('0',15);                       // 13.3R -> DESCONTO-3. VALOR DO DESCONTO

	$linha_r .= '2';                                     // 14.3R -> MULTA. COD. DESCONTO / 0=sem / 1=valor fixo / 2=valor percentual
    $linha_r .= picture_9($data_juros,8);                // 15.3R -> MULTA. DATA DA MULTA 
    $linha_r .=	picture_9('200',15);                     // 16.3R -> MULTA. VALOR DA MULTA

	$linha_r .= complementoRegistro(10,"brancos");       // 17.3R -> INFORMACAO AO PAGADOR - preencher com espacos
	$linha_r .= complementoRegistro(40,"brancos");       // 18.3R -> INFORMACAO 3 - mensagem 3
	$linha_r .= complementoRegistro(40,"brancos");       // 19.3R -> INFORMACAO 4 - Mensagem 4
	$linha_r .= complementoRegistro(50,"brancos");       // 20.3R -> e-mail pagador - e-mail pagador para envio de informacoes
	$linha_r .= complementoRegistro(11,"brancos");       // 21.3R -> Zeros
	$linha_r .= chr(13).chr(10);                         // essa  a quebra de linha
		
	$lote_sequencial++;
	
 	$num_seg_linha_p_q_r++;
	
	$conteudo_meio .= $linha_p.$linha_q.$linha_r;

	$linha_p = "";
	$linha_q = "";
	$linha_r = "";

// **********************

} // final do for $j para extrair os dados dos clientes




	// *****************************************************************************************************************
	// DESCRICAO DE REGISTRO TIPO "5"
	// TRAILER DE LOTE DE ARQUIVO REMESSA
	// PARTE 5 - PNULTIMA LINHA DO ARQUIVO
	// TAMANHO DO REGISTRO = 240 CARACTERES
	// *****************************************************************************************************************
	// NO ALTERAR A VARIAVEL [ $linha_5 ] ABAIXO
	// *****************************************************************************************************************
	
	$linha_5 .= '104';                                   // 01.5 -> COD. DO BANCO. CAIXA = 104
    $linha_5 .= picture_9($lote_servico,4);              // 02.5 -> CONTROLE -> Lote de servico equivalente a 02.1
    $linha_5 .= '5';                                     // 03.5 -> CONTROLE -> Tipo de registro, preencher com '5' equivalente a (Trailer de Lote).
    $linha_5 .= complementoRegistro(9,"brancos");        // 04.9 -> CNAB. FIller, preencher com espacos
	$qtd_registros = ($lote_sequencial*3)+2-1-1;
    $linha_5 .= picture_9(($qtd_registros-1),6);         // 05.5 -> Qtd. de registros no lote. Somatoria dos registros de tipo 1, 3 e 5 ( obs alex = total de linhas -2 )
    $linha_5 .= picture_9($qtd_titulos,6);               // 06.5 -> TOTALIZACAO COBRANCA SIMPLES - Preencher com a qtd. de titulos informados no lote
    $linha_5 .=	picture_9($total_valor,17);              // 07.5 -> TOTALIZACAO COBRANCA SIMPLES - Preencher com o valor total de titulos informados no lote   
    $linha_5 .= complementoRegistro(6,"zeros");          // 08.5 -> Preencher com zeros     
    $linha_5 .= complementoRegistro(17,"zeros");         // 09.5 -> Preencher com zeros     
    $linha_5 .= complementoRegistro(6,"zeros");          // 10.5 -> Preencher com zeros     
    $linha_5 .= complementoRegistro(17,"zeros");         // 11.5 -> Preencher com zeros     
    $linha_5 .= complementoRegistro(31,"brancos");       // 12.5 -> CNAB -> Filler -> Preencher com espacos
    $linha_5 .= complementoRegistro(117,"brancos");      // 13.5 -> CNAB -> Filler -> Preencher com espacos

	$linha_5 .= chr(13).chr(10);                         // essa  a quebra de linha


	// *****************************************************************************************************************
	// DESCRICAO DE REGISTRO TIPO "9"
	// TRAILER DE ARQUIVO REMESSA
	// PARTE 5 - FINAL OU RODAPE DO ARQUIVO
	// TAMANHO DO REGISTRO = 240 CARACTERES
	// *****************************************************************************************************************
	// NO ALTERAR A VARIAVEL [ $linha_9 ] ABAIXO
	// *****************************************************************************************************************

	$qtd_lotes_arquivo = $lote_servico;
	$qtd_reg_arq = ($lote_sequencial*3)+2-1+1-1;                 

	$linha_9 .= '104';                                   // 01.9 -> COD. DO BANCO. CAIXA = 104
	$linha_9 .= '9999';                                  // 02.9 -> lote de servio. Preencher '9999'
	$linha_9 .= '9';                                     // 03.9 -> Tipo de registro. Preencher '9'
	$linha_9 .= complementoRegistro(9,"brancos");        // 04.9 -> CNAB. FIller
	$linha_9 .= picture_9($qtd_lotes_arquivo,6);         // 05.9 -> Quantidade de lotes do arquivo
	$linha_9 .= picture_9($qtd_reg_arq,6);               // 06.9 -> Quantidade de registros no arquivo
	$linha_9 .= complementoRegistro(6,"brancos");        // 07.9 -> Espacos
	$linha_9 .= complementoRegistro(105,"brancos");      // 08.9 -> Espacos
	$linha_9 .= complementoRegistro(100,"brancos");      // ajuste alex para completar as 240 posicoes dessa linha de rodape
	
	$conteudo = $header.$header_lote.$conteudo_meio.$linha_5.$linha_9;

// Em nosso exemplo, ns vamos abrir o arquivo $filename
// em modo de adio. O ponteiro do arquivo estar no final
// do arquivo, e  pra l que $conteudo ir quando o 
// escrevermos com fwrite().
// 'w+' e 'w' apaga tudo e escreve do zero
// 'a+' comeca a escrever do inicio para o fim preservando o conteudo do arquivo

if (!$handle = fopen($filename, 'w+')){
	erro("Nao foi possvel abrir o arquivo $filename<br>");
}

// Escreve $conteudo no nosso arquivo aberto.
if (fwrite($handle, "$conteudo") === FALSE){
	echo "Nao foi possvel escrever no arquivo $filename<br>";
}
fclose($handle);

echo "Arquivo de remessa gerado com sucesso!<br>";

?>


<?php
// TRANSFERINDO O ARQUIVO QUE JA' DEVE TER SIDO BAIXADO NO SEU PC PARA O SERVIDOR

	$xdestino = "remessa/".$filename;    // CONSIDERANDO QUE EXISTA UMA PASTA CHAMADA remessa NA RAIZ DO SEU SERVIDOR
	
	$xorigem = $filename;

	@copy($xorigem,$xdestino);
	
	$arquivo = $filename;
	//echo "<br>passei aqui na hora de copiar....";

?>